using System;
using System.Collections.Generic;
using System.Text;
using Persistate;
using DeviceNetwork.Model;

namespace DeviceNetwork.Controller
{
	/// <summary>
	/// This static class contains controller methods for the operations 
	/// defined for the Collection operation group.
	/// </summary>
	public static class CollectionOperations
	{
		/// <summary>
		/// Executes the Refresh all operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Refresh all operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteRefreshAll(Execution execution)
		{
			return StandardOperations.ExecuteRefreshAll(execution);
		}

		/// <summary>
		/// Executes the New operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the New operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteNew(Execution execution)
		{
			return StandardOperations.ExecuteNew(execution);
		}

		/// <summary>
		/// Executes the Delete operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Delete operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteDelete(Execution execution)
		{
			return StandardOperations.ExecuteDelete(execution);
		}

		/// <summary>
		/// Executes the Add operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Add operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteAdd(Execution execution)
		{
			return StandardOperations.ExecuteAdd(execution);
		}

		/// <summary>
		/// Executes the Remove operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Remove operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteRemove(Execution execution)
		{
			return StandardOperations.ExecuteRemove(execution);
		}

		/// <summary>
		/// Executes the Insert operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Insert operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteInsert(Execution execution)
		{
			return StandardOperations.ExecuteInsert(execution);
		}

		/// <summary>
		/// Executes the Move up operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Move up operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteMoveUp(Execution execution)
		{
			return StandardOperations.ExecuteMoveUp(execution);
		}

		/// <summary>
		/// Executes the Move down operation in the 
		/// Collection group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Move down operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteMoveDown(Execution execution)
		{
			return StandardOperations.ExecuteMoveDown(execution);
		}

	}
}

