using System;
using System.Collections.Generic;
using System.Text;
using Persistate;
using DeviceNetwork.Model;

namespace DeviceNetwork.Controller
{
	/// <summary>
	/// This static class contains controller methods for the operations 
	/// defined for the File operation group.
	/// </summary>
	public static class FileOperations
	{
		/// <summary>
		/// Executes the Exit operation in the 
		/// File group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Exit operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteExit(Execution execution)
		{
			return StandardOperations.ExecuteExit(execution);
		}

		/// <summary>
		/// Executes the Save operation in the 
		/// File group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Save operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteSave(Execution execution)
		{
			return StandardOperations.ExecuteSave(execution);
		}

		/// <summary>
		/// Executes the Revert operation in the 
		/// File group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Revert operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteRevert(Execution execution)
		{
			return StandardOperations.ExecuteRevert(execution);
		}

		/// <summary>
		/// Executes the Login operation in the 
		/// File group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Login operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteLogin(Execution execution, Credentials credentials)
		{
			return StandardOperations.ExecuteLogin(execution, credentials);
		}

	}
}

