using System;
using System.Collections.Generic;
using System.Text;
using Persistate;
using DeviceNetwork.Model;

namespace DeviceNetwork.Controller
{
	/// <summary>
	/// This class contains the InitController method which is called 
	/// from the Main method of the StartUp class, and also by the Persistate
	/// Server application when starting a session for the DeviceNetwork package.
	/// </summary>
	public static class InitialiseController
	{
		/// <summary>
		/// Initialises the Controller module of the DeviceNetwork package.
		/// </summary>
		public static void InitController(Session session)
		{
			// Handle SessionEnding event for this session
			session.SessionEnding += new EventHandler(session_SessionEnding);

			// Set up event handlers
			Cable.SetEventHandlers();
			Connector.SetEventHandlers(session);

			// TODO Perform any required initialisation of the controller at startup.
		}

		// Event handler for the Session.SessionEnding event
		private static void session_SessionEnding(object sender, EventArgs e)
		{
			// TODO Perform any action required when the DeviceNetwork session is ending
		}
	}
}
