using System;
using System.Collections.Generic;
using System.Text;
using Persistate;
using DeviceNetwork.Model;

namespace DeviceNetwork.Controller
{
	/// <summary>
	/// This static class contains controller methods for the operations 
	/// defined for the Object operation group.
	/// </summary>
	public static class ObjectOperations
	{
		/// <summary>
		/// Executes the Refresh operation in the 
		/// Object group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Refresh operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteRefresh(Execution execution)
		{
			return StandardOperations.ExecuteRefresh(execution);
		}

		/// <summary>
		/// Executes the Show operation in the 
		/// Object group.
		/// </summary>
		/// <param name="execution">The operation Execution object created for the
		/// execution of the Show operation.</param>
		/// <returns>An ExecutionResult which should be set with the result
		/// of the operation.</returns>
		public static ExecutionResult ExecuteShow(Execution execution, Layout layout, string paneName)
		{
			return StandardOperations.ExecuteShow(execution, layout, paneName);
		}

	}
}

