using System;
using System.Collections.Generic;
using System.Text;
using Persistate;

namespace DeviceNetwork.Model
{
	/// <summary>  
	/// TODO write summary documentation
	/// </summary>
	public partial class Cable : Persistent
	{
		/// <summary>
		/// Set up event handling
		/// </summary>
		public static void SetEventHandlers()
		{
			Cable.ItsObjectClass.InstanceAssociated
				 += new LinkageEventHandler(Cable_InstanceAssociated);
			Cable.ItsObjectClass.InstanceDissociated
				 += new LinkageEventHandler(Cable_InstanceDissociated);
		}

		// when cable associated to connector, add connector to cable's plugged into collection
		private static void Cable_InstanceAssociated(object sender, LinkageEventArgs args)
		{
			Connector connector = args.Container as Connector;
			if (connector != null)
				((Cable)args.Containee).PluggedInto.AddIfAbsent(connector);
		}

		// when cable dissociated from connector, remove connector from cable's plugged into collection
		private static void Cable_InstanceDissociated(object sender, LinkageEventArgs args)
		{
			Connector connector = args.Container as Connector;
			if (connector != null)
				((Cable)args.Containee).PluggedInto.Remove(connector);
		}
		
	}

}