using System;
using System.Data;
using Persistate;

namespace DeviceNetwork.Model
{
	
	// This Cable partial class has been generated by Persistate.  Do
	// not modify as the entire file is recreated on each generation.

	[System.Diagnostics.DebuggerDisplay("Cable {NominativeText}")]	
	public partial class Cable : Persistent
	{
		private static ObjectClass objClass = null;	// set at start of session

		/// <summary> Sets the objClass static field for this class. </summary>
		public new static void SetObjectClass(ObjectClass oc) {
			objClass = oc;
		}
		/// <summary> Gets the ObjectClass object associated with this object. </summary>
		public override ObjectClass Class {
			get { return objClass; }
		}
		/// <summary> Gets the ObjectClass object associated with this class. </summary>
		public new static ObjectClass ItsObjectClass {
			get { return objClass; }
		}
		/// <summary> Creates a new Cable with default property values </summary>
		public Cable() : this(true, true) { 
		}
		/// <exclude />
		/// <summary> Creates a new Cable with optional default property values </summary>
		public Cable(bool initScalars, bool initCollections) : base(false, false) {
			InitialiseMembers(initScalars, initCollections);
		}
		/// <exclude />
		/// <summary> Creates a new Cable with its reference and parent. </summary>
		protected Cable(Reference thisObj, IReference parentObj) 
			: base(thisObj, parentObj) {}

		/// <summary> Gets the class flags for the Cable class. </summary>
		public override FlagSet ClassFlags {
			get { return new FlagSet(FlagSet.CloneOnMutate |FlagSet.UseCache); }
		}
		/// <exclude />
		/// <summary> Creates a new Cable from data read from persistent storage. </summary>
		public new static Cable CreateFromDatabase(Database db, IDataReader dr, Reference thisObj, Persistent parentObj) {
			Cable obj = new Cable(thisObj, parentObj);
			obj.FillFromDatabase(db, dr);
			return obj;
		}
		/// <exclude />
		/// <summary> Populates this object from data read from persistent storage. </summary>
		public override void FillFromDatabase(Database db__, IDataReader dr__) {
			base.FillFromDatabase(db__, dr__);
			name = db__.ReadString(dr__, "Cable_name");
			cableType = db__.ReadIReference(dr__, "Cable_cableType");
			cableColour = db__.ReadPColor(dr__, "Cable_cableColour");
		}
		/// <exclude />
		/// <summary> Populates persistent storage update parameters from this object. </summary>
		public override bool SaveToDatabase(Database db__, Reference id__, object context__) {
			bool reSave__;
			do {
				db__.SetParameter("id", id__);
				db__.SetParameter("parent", ParentReference);
				db__.SetParameter("oldVersion", PreviousVersion == null
					? VersionNumber - 1 : PreviousVersion.VersionNumber);
				db__.SetParameter("newVersion", VersionNumber);
				db__.SetParameter("Name", name);
				db__.SetParameter("CableType", cableType);
				db__.SetParameter("CableColour", cableColour);
				if (!db__.SaveObject(context__, objClass, out reSave__))
					return false;
			} while (reSave__);		// save again if an update conflict on first try was resolved
			return true;
		}
		/// <exclude />
		/// <summary> Creates a new Cable from a Persistate.Message. </summary>
		public new static Cable CreateFromMessage(Message message, Reference thisObj, IReference parentObj) {
			Cable obj = new Cable(thisObj, parentObj);
			obj.FillFromMessage(message);
			return obj;
		}
		/// <exclude />
		/// <summary> Sets a single member value for a given slot from a message. </summary>
		protected override void SetMemberFromMessage(int slot__, int length__, Message message__) {
			switch (slot__) {
				case 1: name = message__.ReadString(); break;
				case 2: cableType = message__.ReadIReference(); break;
				case 3: cableColour = message__.ReadPColor(); break;
				default: base.SetMemberFromMessage(slot__, length__, message__); break;
			}
		}
		/// <exclude />
		/// <summary> Populates a Persistate.Message from this object. </summary>
		protected override void SaveToMessage(Message message__, bool topLevel__) {
			base.SaveToMessage(message__, false);
			message__.Append(1, name);
			message__.Append(2, cableType);
			message__.Append(3, cableColour);
			if (topLevel__)
				message__.Append(-1);
		}
		/// <exclude />
		/// <summary> Initialises members of a Cable object to default values. </summary>
		public override void InitialiseMembers(bool initScalars__, bool initCollections__) {
			base.InitialiseMembers(initScalars__, initCollections__);
			if (initScalars__) {
				name = String.Empty;
			}
			if (initCollections__) {
				pluggedInto = Connector.Collection(this, PluggedIntoFlagSet, 4, false);
			}
		}
		/// <exclude />
		/// <summary> Removes this Cable and all objects under it from persistent storage. </summary>
		public override void DePersist(object context__) {
			DeAssociate(this, cableType, 2);
			foreach (Connector obj in PluggedInto)
				obj.DePersistFrom(PluggedInto, context__);
			base.DePersist(context__);
		}
		/// <exclude />
		/// <summary> calls a method for every node in the persistent tree under this object. </summary>
		public override bool CallTree(CallTreeData callTreeData__, int slot__) {
			if (callTreeData__.RootFirst && !base.CallTree(callTreeData__, slot__))
				return false;
			callTreeData__.TreeCallAssociated(CableType, this, 2, callTreeData__);
			callTreeData__.TreeCallAssociated(PluggedInto, this, 4, callTreeData__);
			if (!callTreeData__.RootFirst)
				base.CallTree(callTreeData__, slot__);
			return true;
		}
		/// <summary> Gets the value of the member property with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the member with the given slot. </returns>
		public override object GetMemberValue(int slot__) {
			switch (slot__) {
				case 1: return Name;
				case 2: return CableType;
				case 3: return CableColour;
				case 4: return PluggedInto;
				default: return base.GetMemberValue(slot__);
			}
		}
		/// <summary> Sets the value of the member property with a particularn slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the member with the given slot. </param>
		public override void SetMemberValue(int slot__, object value__) {
			switch (slot__) {
				case 1: Name = ValueOf<String>(value__); break;
				case 2: CableType = (CableType)value__; break;
				case 3: CableColour = ValueOf<Persistate.UI.PColor>(value__); break;
				default: base.SetMemberValue(slot__, value__); break;
			}
		}
		/// <summary> Gets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the field with the given slot. </returns>
		public override object GetFieldValue(int slot__) {
			switch (slot__) {
				case 1: return name;
				case 2: return cableType;
				case 3: return cableColour;
				case 4: return pluggedInto;
				default: return base.GetFieldValue(slot__);
			}
		}
		/// <summary> Sets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the field with the given slot. </param>
		public override void SetFieldValue(int slot__, object value__) {
			switch (slot__) {
				case 1: name = ValueOf<String>(value__); break;
				case 2: cableType = (IReference)value__; break;
				case 3: cableColour = ValueOf<Persistate.UI.PColor>(value__); break;
				default: base.SetFieldValue(slot__, value__); break;
			}
		}
		/// <summary> Creates a Cable collection to contain provisional objects. </summary>
		/// <returns> An empty IndexedList(Cable) collection. </returns>
		public new static IndexedList<Cable> Collection() {
			return new IndexedList<Cable>(ItsObjectClass, null, FlagSet.Associated, 0, false, 1, 0);
		}
		/// <summary> Creates a Cable collection to contain persistent objects. </summary>
		/// <param name="parent"> The parent object of the collection. </param>
		/// <param name="flags"> A FlagSet containing the collection flags. </param>
		/// <param name="slot"> The slot of its parent member containing the collection. </param>
		/// <param name="getData"> If true, objects belonging in the collection are fetched from persistent storage. </param>
		/// <returns> An IndexedList(Cable) containing the new collection. </returns>
		public new static IndexedList<Cable> Collection(Persistent parent, FlagSet flags, int slot, bool getData) {
			return new IndexedList<Cable>(ItsObjectClass, parent, flags, slot, getData, 1, 0);
		}
		/// <summary> Gets the Parent object as a Network. </summary>
		public Network ParentNetwork {
			get { return Parent as Network; }
		}
		//		Property for name
		private String name;
		/// <summary> Property for name. </summary> 
		public String Name {
			get { return name; }
			set { SetModified();  name = value;  OnModified(); }
		}
		//		Property for cable type
		private IReference cableType;
		/// <summary> Property for cable type. </summary> 
		public CableType CableType {
			get {
				if (!(cableType is CableType) && cableType != null) 
					lock (locker) cableType = cableType.DeReference(null);
				return (CableType)cableType;
			}
			set { Associate(value, ref cableType, 2); } 
		}
		//		Property for cable_ colour
		private Persistate.UI.PColor cableColour;
		/// <summary> Property for cable colour. </summary> 
		public Persistate.UI.PColor CableColour {
			get { return cableColour; }
			set { SetModified();  cableColour = value;  OnModified(); }
		}
		//		Property for plugged into connectors
		private IndexedList<Connector> pluggedInto = null;
		private static readonly FlagSet PluggedIntoFlagSet = FlagSet.Associated |FlagSet.MultipleObject |FlagSet.UseLinkTable;
		/// <summary> Property for plugged into. </summary> 
		public IndexedList<Connector> PluggedInto {
			get {
				if (pluggedInto == null) lock (locker) if (pluggedInto == null)
					pluggedInto = Connector.Collection(this, PluggedIntoFlagSet, 4, true);
				return pluggedInto;
			}
		}
		/// <summary> Gets the number of items in the PluggedInto collection. </summary>
		public int PluggedIntoCount {
			get { return PluggedInto.Count; }
		}
		/// <summary> Key value for name index. </summary>
		public const int NameKey = 0;

		/// <summary> Returns property value for given key number. </summary>
		/// <param name="keyNum__"> The key number to use. </param>
		/// <returns> an object containing the value of the property indicated by the given key.  </returns>
		public override object GetKey(int keyNum__) {
			switch (keyNum__) {
				case NameKey: return Name;
				default: return base.GetKey(keyNum__);
			}
		}
		/// <summary> Gets a string containing values of nominative properties. </summary>
		public override string NominativeText {
			get { return Utl.Join(AnnotationSeparator, base.NominativeText, Name); }
		}
		/// <summary> Gets a string containing values of discriminative properties. </summary>
		public override string DiscriminativeText {
			get { return Utl.Join(AnnotationSeparator, base.DiscriminativeText, Name, CableType.DiscriminativeText, CableColour.ToString()); }
		}
	}

}