using System;
using System.Data;
using Persistate;

namespace DeviceNetwork.Model
{
	
	// This ConnectedDevice partial class has been generated by Persistate.  Do
	// not modify as the entire file is recreated on each generation.

	[System.Diagnostics.DebuggerDisplay("ConnectedDevice {NominativeText}")]	
	public partial class ConnectedDevice : Persistent
	{
		private static ObjectClass objClass = null;	// set at start of session

		/// <summary> Sets the objClass static field for this class. </summary>
		public new static void SetObjectClass(ObjectClass oc) {
			objClass = oc;
		}
		/// <summary> Gets the ObjectClass object associated with this object. </summary>
		public override ObjectClass Class {
			get { return objClass; }
		}
		/// <summary> Gets the ObjectClass object associated with this class. </summary>
		public new static ObjectClass ItsObjectClass {
			get { return objClass; }
		}
		/// <summary> Creates a new empty ConnectedDevice </summary>
		public ConnectedDevice() : base(false, false) { }
		
		/// <summary> Gets the class flags for the ConnectedDevice class. </summary>
		public override FlagSet ClassFlags {
			get { return new FlagSet(FlagSet.Empty); }
		}
		/// <summary> Creates a new ConnectedDevice from data read from persistent storage. </summary>
		public new static ConnectedDevice CreateFromDatabase(Database db, IDataReader dr, Reference thisObj, Persistent parentObj) {
			ConnectedDevice obj = new ConnectedDevice();
			obj.FillFromDatabase(db, dr);
			return obj;
		}
		/// <summary> Populates this object from data read from persistent storage. </summary>
		public override void FillFromDatabase(Database db__, IDataReader dr__) {
			name = db__.ReadString(dr__, "ConnectedDevice_name");
			cableName = db__.ReadString(dr__, "ConnectedDevice_cableName");
			deviceName = db__.ReadString(dr__, "ConnectedDevice_deviceName");
			deviceType = db__.ReadIReference(dr__, "ConnectedDevice_deviceType");
			device = db__.ReadIReference(dr__, "ConnectedDevice_device");
		}
		/// <summary> Creates a new ConnectedDevice from a Persistate.Message. </summary>
		public new static ConnectedDevice CreateFromMessage(Message message, Reference thisObj, IReference parentObj) {
			ConnectedDevice obj = new ConnectedDevice();
			obj.FillFromMessage(message);
			return obj;
		}
		/// <summary> Sets a single member value for a given slot from a message. </summary>
		protected override void SetMemberFromMessage(int slot__, int length__, Message message__) {
			switch (slot__) {
				case 1: name = message__.ReadString(); break;
				case 2: cableName = message__.ReadString(); break;
				case 3: deviceName = message__.ReadString(); break;
				case 4: deviceType = message__.ReadIReference(); break;
				case 5: device = message__.ReadIReference(); break;
				default: base.SetMemberFromMessage(slot__, length__, message__); break;
			}
		}
		/// <summary> Populates a Persistate.Message from this object. </summary>
		protected override void SaveToMessage(Message message__, bool topLevel__) {
			base.SaveToMessage(message__, false);
			message__.Append(1, name);
			message__.Append(2, cableName);
			message__.Append(3, deviceName);
			message__.Append(4, deviceType);
			message__.Append(5, device);
			if (topLevel__)
				message__.Append(-1);
		}
		/// <summary> Gets the value of the member with the given slot number. </summary>
		public override object GetMemberValue(int slot__) {
			switch (slot__) {
				case 1: return Name;
				case 2: return CableName;
				case 3: return DeviceName;
				case 4: return DeviceType;
				case 5: return Device;
				default: return base.GetMemberValue(slot__);
			}
		}
		/// <summary> Gets the value of the member with the given slot number. </summary>
		public override void SetMemberValue(int slot__, object value__) {
			switch (slot__) {
				default: base.SetMemberValue(slot__, value__); break;
			}
		}
		/// <summary> Gets the value of the field with the given slot number. </summary>
		public override object GetFieldValue(int slot__) {
			switch (slot__) {
				case 1: return name;
				case 2: return cableName;
				case 3: return deviceName;
				case 4: return deviceType;
				case 5: return device;
				default: return base.GetFieldValue(slot__);
			}
		}
		/// <summary> Sets the value of the field with the given slot number. </summary>
		public override void SetFieldValue(int slot__, object value__) {
			switch (slot__) {
				default: base.SetFieldValue(slot__, value__); break;
			}
		}
		/// <summary> Creates a ConnectedDevice collection to contain provisional objects </summary>
		public new static IndexedList<ConnectedDevice> Collection() {
			return new IndexedList<ConnectedDevice>(ItsObjectClass, null, FlagSet.Associated, 0, false, 0, -1);
		}
		/// <summary> Creates a ConnectedDevice collection to contain persistent objects </summary>
		public new static IndexedList<ConnectedDevice> Collection(Persistent parent, FlagSet flags, int slot, bool getData) {
			return new IndexedList<ConnectedDevice>(ItsObjectClass, parent, flags, slot, getData, 0, -1);
		}
		/// <summary> Gets the Parent object as a Device. </summary>
		public Device ParentDevice {
			get { return Parent as Device; }
		}
		//		Property for name
		private String name;
		/// <summary> Property for name. </summary> 
		public String Name {
			get { return name; }
		}
		//		Property for cable name
		private String cableName;
		/// <summary> Property for cable name. </summary> 
		public String CableName {
			get { return cableName; }
		}
		//		Property for device name
		private String deviceName;
		/// <summary> Property for device name. </summary> 
		public String DeviceName {
			get { return deviceName; }
		}
		//		Property for device type
		private IReference deviceType;
		/// <summary> Property for device type. </summary> 
		public DeviceType DeviceType {
			get {
				if (!(deviceType is DeviceType) && deviceType != null) 
					lock (locker) deviceType = deviceType.DeReference(null);
				return (DeviceType)deviceType;
			} 
		}
		//		Property for device
		private IReference device;
		/// <summary> Property for device. </summary> 
		public Device Device {
			get {
				if (!(device is Device) && device != null) 
					lock (locker) device = device.DeReference(null);
				return (Device)device;
			} 
		}
		/// <summary> Returns property value for given key number. </summary>
		public override object GetKey(int keyNum__) {
			switch (keyNum__) {
				default: return base.GetKey(keyNum__);
			}
		}
		/// <summary> Gets a string containing values of nominative properties. </summary>
		public override string NominativeText {
			get { return Utl.Join(AnnotationSeparator, base.NominativeText); }
		}
		/// <summary> Gets a string containing values of discriminative properties. </summary>
		public override string DiscriminativeText {
			get { return Utl.Join(AnnotationSeparator, base.DiscriminativeText); }
		}
	}

}