using System;
using System.Data;
using Persistate;

namespace DeviceNetwork.Model
{
	
	// This Connector partial class has been generated by Persistate.  Do
	// not modify as the entire file is recreated on each generation.

	[System.Diagnostics.DebuggerDisplay("Connector {NominativeText}")]	
	public partial class Connector : Persistent
	{
		private static ObjectClass objClass = null;	// set at start of session

		/// <summary> Sets the objClass static field for this class. </summary>
		public new static void SetObjectClass(ObjectClass oc) {
			objClass = oc;
		}
		/// <summary> Gets the ObjectClass object associated with this object. </summary>
		public override ObjectClass Class {
			get { return objClass; }
		}
		/// <summary> Gets the ObjectClass object associated with this class. </summary>
		public new static ObjectClass ItsObjectClass {
			get { return objClass; }
		}
		/// <summary> Creates a new Connector with default property values </summary>
		public Connector() : this(true, true) { 
		}
		/// <exclude />
		/// <summary> Creates a new Connector with optional default property values </summary>
		public Connector(bool initScalars, bool initCollections) : base(false, false) {
			InitialiseMembers(initScalars, initCollections);
		}
		/// <exclude />
		/// <summary> Creates a new Connector with its reference and parent. </summary>
		protected Connector(Reference thisObj, IReference parentObj) 
			: base(thisObj, parentObj) {}

		/// <summary> Gets the class flags for the Connector class. </summary>
		public override FlagSet ClassFlags {
			get { return new FlagSet(FlagSet.CloneOnMutate |FlagSet.UseCache); }
		}
		/// <exclude />
		/// <summary> Creates a new Connector from data read from persistent storage. </summary>
		public new static Connector CreateFromDatabase(Database db, IDataReader dr, Reference thisObj, Persistent parentObj) {
			Connector obj = new Connector(thisObj, parentObj);
			obj.FillFromDatabase(db, dr);
			return obj;
		}
		/// <exclude />
		/// <summary> Populates this object from data read from persistent storage. </summary>
		public override void FillFromDatabase(Database db__, IDataReader dr__) {
			base.FillFromDatabase(db__, dr__);
			name = db__.ReadString(dr__, "Connector_name");
			direction = db__.ReadInt32(dr__, "Connector_direction");
			connectorType = db__.ReadIReference(dr__, "Connector_connectorType");
			cable = db__.ReadIReference(dr__, "Connector_cable");
		}
		/// <exclude />
		/// <summary> Populates persistent storage update parameters from this object. </summary>
		public override bool SaveToDatabase(Database db__, Reference id__, object context__) {
			bool reSave__;
			do {
				db__.SetParameter("id", id__);
				db__.SetParameter("parent", ParentReference);
				db__.SetParameter("oldVersion", PreviousVersion == null
					? VersionNumber - 1 : PreviousVersion.VersionNumber);
				db__.SetParameter("newVersion", VersionNumber);
				db__.SetParameter("Name", name);
				db__.SetParameter("Direction", direction);
				db__.SetParameter("ConnectorType", connectorType);
				db__.SetParameter("Cable", cable);
				if (!db__.SaveObject(context__, objClass, out reSave__))
					return false;
			} while (reSave__);		// save again if an update conflict on first try was resolved
			return true;
		}
		/// <exclude />
		/// <summary> Creates a new Connector from a Persistate.Message. </summary>
		public new static Connector CreateFromMessage(Message message, Reference thisObj, IReference parentObj) {
			Connector obj = new Connector(thisObj, parentObj);
			obj.FillFromMessage(message);
			return obj;
		}
		/// <exclude />
		/// <summary> Sets a single member value for a given slot from a message. </summary>
		protected override void SetMemberFromMessage(int slot__, int length__, Message message__) {
			switch (slot__) {
				case 1: name = message__.ReadString(); break;
				case 2: direction = message__.ReadInt32(); break;
				case 3: connectorType = message__.ReadIReference(); break;
				case 4: cable = message__.ReadIReference(); break;
				default: base.SetMemberFromMessage(slot__, length__, message__); break;
			}
		}
		/// <exclude />
		/// <summary> Populates a Persistate.Message from this object. </summary>
		protected override void SaveToMessage(Message message__, bool topLevel__) {
			base.SaveToMessage(message__, false);
			message__.Append(1, name);
			message__.Append(2, direction);
			message__.Append(3, connectorType);
			message__.Append(4, cable);
			if (topLevel__)
				message__.Append(-1);
		}
		/// <exclude />
		/// <summary> Initialises members of a Connector object to default values. </summary>
		public override void InitialiseMembers(bool initScalars__, bool initCollections__) {
			base.InitialiseMembers(initScalars__, initCollections__);
			if (initScalars__) {
				name = String.Empty;
			}
			if (initCollections__) {
			}
		}
		/// <exclude />
		/// <summary> Removes this Connector and all objects under it from persistent storage. </summary>
		public override void DePersist(object context__) {
			DeAssociate(this, connectorType, 3);
			DeAssociate(this, cable, 4);
			base.DePersist(context__);
		}
		/// <exclude />
		/// <summary> calls a method for every node in the persistent tree under this object. </summary>
		public override bool CallTree(CallTreeData callTreeData__, int slot__) {
			if (callTreeData__.RootFirst && !base.CallTree(callTreeData__, slot__))
				return false;
			callTreeData__.TreeCallAssociated(ConnectorType, this, 3, callTreeData__);
			callTreeData__.TreeCallAssociated(Cable, this, 4, callTreeData__);
			if (!callTreeData__.RootFirst)
				base.CallTree(callTreeData__, slot__);
			return true;
		}
		/// <summary> Gets the value of the member property with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the member with the given slot. </returns>
		public override object GetMemberValue(int slot__) {
			switch (slot__) {
				case 1: return Name;
				case 2: return Direction;
				case 3: return ConnectorType;
				case 4: return Cable;
				case 5: return DeviceName;
				case 6: return Go;
				default: return base.GetMemberValue(slot__);
			}
		}
		/// <summary> Sets the value of the member property with a particularn slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the member with the given slot. </param>
		public override void SetMemberValue(int slot__, object value__) {
			switch (slot__) {
				case 1: Name = ValueOf<String>(value__); break;
				case 2: Direction = ValueOf<Direction>(value__); break;
				case 3: ConnectorType = (ConnectorType)value__; break;
				case 4: Cable = (Cable)value__; break;
				default: base.SetMemberValue(slot__, value__); break;
			}
		}
		/// <summary> Gets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the field with the given slot. </returns>
		public override object GetFieldValue(int slot__) {
			switch (slot__) {
				case 1: return name;
				case 2: return direction;
				case 3: return connectorType;
				case 4: return cable;
				default: return base.GetFieldValue(slot__);
			}
		}
		/// <summary> Sets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the field with the given slot. </param>
		public override void SetFieldValue(int slot__, object value__) {
			switch (slot__) {
				case 1: name = ValueOf<String>(value__); break;
				case 2: direction = ValueOf<Direction>(value__); break;
				case 3: connectorType = (IReference)value__; break;
				case 4: cable = (IReference)value__; break;
				default: base.SetFieldValue(slot__, value__); break;
			}
		}
		/// <summary> Creates a Connector collection to contain provisional objects. </summary>
		/// <returns> An empty IndexedList(Connector) collection. </returns>
		public new static IndexedList<Connector> Collection() {
			return new IndexedList<Connector>(ItsObjectClass, null, FlagSet.Associated, 0, false, 1, 0);
		}
		/// <summary> Creates a Connector collection to contain persistent objects. </summary>
		/// <param name="parent"> The parent object of the collection. </param>
		/// <param name="flags"> A FlagSet containing the collection flags. </param>
		/// <param name="slot"> The slot of its parent member containing the collection. </param>
		/// <param name="getData"> If true, objects belonging in the collection are fetched from persistent storage. </param>
		/// <returns> An IndexedList(Connector) containing the new collection. </returns>
		public new static IndexedList<Connector> Collection(Persistent parent, FlagSet flags, int slot, bool getData) {
			return new IndexedList<Connector>(ItsObjectClass, parent, flags, slot, getData, 1, 0);
		}
		/// <summary> Gets the Parent object as a Device. </summary>
		public Device ParentDevice {
			get { return Parent as Device; }
		}
		//		Property for name
		private String name;
		/// <summary> Property for name. </summary> 
		public String Name {
			get { return name; }
			set { SetModified();  name = value;  OnModified(); }
		}
		//		Property for direction
		private Direction direction;
		/// <summary> Property for direction. </summary> 
		[System.Xml.Serialization.XmlElement(typeof(string), ElementName = "Direction")]
		public  Direction Direction {
			get { return direction; }
			set { SetModified();  direction = value;  OnModified(); }
		}
		//		Property for connector type
		private IReference connectorType;
		/// <summary> Property for connector type. </summary> 
		public ConnectorType ConnectorType {
			get {
				if (!(connectorType is ConnectorType) && connectorType != null) 
					lock (locker) connectorType = connectorType.DeReference(null);
				return (ConnectorType)connectorType;
			}
			set { Associate(value, ref connectorType, 3); } 
		}
		//		Property for cable
		private IReference cable;
		/// <summary> Property for cable. </summary> 
		public Cable Cable {
			get {
				if (!(cable is Cable) && cable != null) 
					lock (locker) cable = cable.DeReference(null);
				return (Cable)cable;
			}
			set { Associate(value, ref cable, 4); } 
		}
		//		Property for device_ name
		/// <summary> Property for device name. </summary> 
		public  String DeviceName {
			get { return ParentDevice.Name; }
		}
		//		Property for go device
		/// <summary> Property for go. </summary> 
		public  Device Go {
			get { return ParentDevice; }
		}
		/// <summary> Key value for name index. </summary>
		public const int NameKey = 0;

		/// <summary> Returns property value for given key number. </summary>
		/// <param name="keyNum__"> The key number to use. </param>
		/// <returns> an object containing the value of the property indicated by the given key.  </returns>
		public override object GetKey(int keyNum__) {
			switch (keyNum__) {
				case NameKey: return Name;
				default: return base.GetKey(keyNum__);
			}
		}
		/// <summary> Gets a string containing values of nominative properties. </summary>
		public override string NominativeText {
			get { return Utl.Join(AnnotationSeparator, base.NominativeText, Name); }
		}
		/// <summary> Gets a string containing values of discriminative properties. </summary>
		public override string DiscriminativeText {
			get { return Utl.Join(AnnotationSeparator, base.DiscriminativeText, Name); }
		}
	}

}