using System;
using System.Data;
using Persistate;

namespace DeviceNetwork.Model
{
	
	// This DeviceType partial class has been generated by Persistate.  Do
	// not modify as the entire file is recreated on each generation.

	[System.Diagnostics.DebuggerDisplay("DeviceType {NominativeText}")]	
	public partial class DeviceType : Persistent
	{
		private static ObjectClass objClass = null;	// set at start of session

		/// <summary> Sets the objClass static field for this class. </summary>
		public new static void SetObjectClass(ObjectClass oc) {
			objClass = oc;
		}
		/// <summary> Gets the ObjectClass object associated with this object. </summary>
		public override ObjectClass Class {
			get { return objClass; }
		}
		/// <summary> Gets the ObjectClass object associated with this class. </summary>
		public new static ObjectClass ItsObjectClass {
			get { return objClass; }
		}
		/// <summary> Creates a new DeviceType with default property values </summary>
		public DeviceType() : this(true, true) { 
		}
		/// <exclude />
		/// <summary> Creates a new DeviceType with optional default property values </summary>
		public DeviceType(bool initScalars, bool initCollections) : base(false, false) {
			InitialiseMembers(initScalars, initCollections);
		}
		/// <exclude />
		/// <summary> Creates a new DeviceType with its reference and parent. </summary>
		protected DeviceType(Reference thisObj, IReference parentObj) 
			: base(thisObj, parentObj) {}

		/// <summary> Gets the class flags for the DeviceType class. </summary>
		public override FlagSet ClassFlags {
			get { return new FlagSet(FlagSet.CloneOnMutate |FlagSet.UseCache |FlagSet.SaveInConfiguration); }
		}
		/// <exclude />
		/// <summary> Creates a new DeviceType from data read from persistent storage. </summary>
		public new static DeviceType CreateFromDatabase(Database db, IDataReader dr, Reference thisObj, Persistent parentObj) {
			DeviceType obj = new DeviceType(thisObj, parentObj);
			obj.FillFromDatabase(db, dr);
			return obj;
		}
		/// <exclude />
		/// <summary> Populates this object from data read from persistent storage. </summary>
		public override void FillFromDatabase(Database db__, IDataReader dr__) {
			base.FillFromDatabase(db__, dr__);
			name = db__.ReadString(dr__, "DeviceType_name");
		}
		/// <exclude />
		/// <summary> Populates persistent storage update parameters from this object. </summary>
		public override bool SaveToDatabase(Database db__, Reference id__, object context__) {
			bool reSave__;
			do {
				db__.SetParameter("id", id__);
				db__.SetParameter("parent", ParentReference);
				db__.SetParameter("oldVersion", PreviousVersion == null
					? VersionNumber - 1 : PreviousVersion.VersionNumber);
				db__.SetParameter("newVersion", VersionNumber);
				db__.SetParameter("Name", name);
				if (!db__.SaveObject(context__, objClass, out reSave__))
					return false;
			} while (reSave__);		// save again if an update conflict on first try was resolved
			return true;
		}
		/// <exclude />
		/// <summary> Creates a new DeviceType from a Persistate.Message. </summary>
		public new static DeviceType CreateFromMessage(Message message, Reference thisObj, IReference parentObj) {
			DeviceType obj = new DeviceType(thisObj, parentObj);
			obj.FillFromMessage(message);
			return obj;
		}
		/// <exclude />
		/// <summary> Sets a single member value for a given slot from a message. </summary>
		protected override void SetMemberFromMessage(int slot__, int length__, Message message__) {
			switch (slot__) {
				case 1: name = message__.ReadString(); break;
				default: base.SetMemberFromMessage(slot__, length__, message__); break;
			}
		}
		/// <exclude />
		/// <summary> Populates a Persistate.Message from this object. </summary>
		protected override void SaveToMessage(Message message__, bool topLevel__) {
			base.SaveToMessage(message__, false);
			message__.Append(1, name);
			if (topLevel__)
				message__.Append(-1);
		}
		/// <exclude />
		/// <summary> Initialises members of a DeviceType object to default values. </summary>
		public override void InitialiseMembers(bool initScalars__, bool initCollections__) {
			base.InitialiseMembers(initScalars__, initCollections__);
			if (initScalars__) {
				name = String.Empty;
			}
			if (initCollections__) {
			}
		}
		/// <exclude />
		/// <summary> Removes this DeviceType and all objects under it from persistent storage. </summary>
		public override void DePersist(object context__) {
			base.DePersist(context__);
		}
		/// <exclude />
		/// <summary> calls a method for every node in the persistent tree under this object. </summary>
		public override bool CallTree(CallTreeData callTreeData__, int slot__) {
			if (callTreeData__.RootFirst && !base.CallTree(callTreeData__, slot__))
				return false;
			if (!callTreeData__.RootFirst)
				base.CallTree(callTreeData__, slot__);
			return true;
		}
		/// <summary> Gets the value of the member property with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the member with the given slot. </returns>
		public override object GetMemberValue(int slot__) {
			switch (slot__) {
				case 1: return Name;
				default: return base.GetMemberValue(slot__);
			}
		}
		/// <summary> Sets the value of the member property with a particularn slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the member with the given slot. </param>
		public override void SetMemberValue(int slot__, object value__) {
			switch (slot__) {
				case 1: Name = ValueOf<String>(value__); break;
				default: base.SetMemberValue(slot__, value__); break;
			}
		}
		/// <summary> Gets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the field with the given slot. </returns>
		public override object GetFieldValue(int slot__) {
			switch (slot__) {
				case 1: return name;
				default: return base.GetFieldValue(slot__);
			}
		}
		/// <summary> Sets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the field with the given slot. </param>
		public override void SetFieldValue(int slot__, object value__) {
			switch (slot__) {
				case 1: name = ValueOf<String>(value__); break;
				default: base.SetFieldValue(slot__, value__); break;
			}
		}
		/// <summary> Creates a DeviceType collection to contain provisional objects. </summary>
		/// <returns> An empty IndexedList(DeviceType) collection. </returns>
		public new static IndexedList<DeviceType> Collection() {
			return new IndexedList<DeviceType>(ItsObjectClass, null, FlagSet.Associated, 0, false, 1, 0);
		}
		/// <summary> Creates a DeviceType collection to contain persistent objects. </summary>
		/// <param name="parent"> The parent object of the collection. </param>
		/// <param name="flags"> A FlagSet containing the collection flags. </param>
		/// <param name="slot"> The slot of its parent member containing the collection. </param>
		/// <param name="getData"> If true, objects belonging in the collection are fetched from persistent storage. </param>
		/// <returns> An IndexedList(DeviceType) containing the new collection. </returns>
		public new static IndexedList<DeviceType> Collection(Persistent parent, FlagSet flags, int slot, bool getData) {
			return new IndexedList<DeviceType>(ItsObjectClass, parent, flags, slot, getData, 1, 0);
		}
		/// <summary> Gets the Parent object as a Network. </summary>
		public Network ParentNetwork {
			get { return Parent as Network; }
		}
		//		Property for name
		private String name;
		/// <summary> Property for name. </summary> 
		public String Name {
			get { return name; }
			set { SetModified();  name = value;  OnModified(); }
		}
		/// <summary> Key value for name index. </summary>
		public const int NameKey = 0;

		/// <summary> Returns property value for given key number. </summary>
		/// <param name="keyNum__"> The key number to use. </param>
		/// <returns> an object containing the value of the property indicated by the given key.  </returns>
		public override object GetKey(int keyNum__) {
			switch (keyNum__) {
				case NameKey: return Name;
				default: return base.GetKey(keyNum__);
			}
		}
		/// <summary> Gets a string containing values of nominative properties. </summary>
		public override string NominativeText {
			get { return Utl.Join(AnnotationSeparator, base.NominativeText, Name); }
		}
		/// <summary> Gets a string containing values of discriminative properties. </summary>
		public override string DiscriminativeText {
			get { return Utl.Join(AnnotationSeparator, base.DiscriminativeText, Name); }
		}
	}

}