using System;
using System.ComponentModel;
using Persistate;

namespace DeviceNetwork.Model
{
	// This Direction partial class has been generated by Persistate.  Do
	// not modify as the entire file is recreated on each generation.

	[System.Diagnostics.DebuggerDisplay("{ToString()} ({ordinal})")]	
	[TypeConverter(typeof(MultiValueConverter))]
	public partial struct Direction : IMultiValue
	{
		/// <summary> Contains the value of the Direction. </summary>
		public int ordinal;

		// IMultiValue property implementations
		
		/// <summary> Gets the integer ordinal value of this Direction. </summary>
		public int Ordinal { get { return ordinal; } set { ordinal = value; } }

		/// <summary> Indicates whether Direction values can be combined. </summary>
		public bool IsCombinable { get { return false; } }

		/// <summary> Gets the array of ISourcePairs holding ordinal and text values. </summary>
		public ISourcePair[] SourcePairs { get { return sourcePairs; } }

		/// <summary> This is the default Direction value. </summary>
		public const int _undefined_ = 0;
		/// <summary> This is the value for input. </summary>
		public const int Input = 1;
		/// <summary> This is the value for output. </summary>
		public const int Output = 2;
		/// <summary> This is the value for bidirectional. </summary>
		public const int Bidirectional = 3;
		/// <summary> This is the value for the top value. </summary>
		public const int TopValue = 3;

		/// <summary> This class represents a text and ordinal pair for Direction values. </summary>
		public class SourcePair : ISourcePair {
			private Direction ordinal_;
			private string text_;

			/// <summary> Gets the ordinal value of the source pair. </summary>
			public Direction ordinal { get { return ordinal_; } }

			// ISourcePair property implementations
			
			/// <summary> Gets the ordinal value of the source pair as an int. </summary>
			public int intOrdinal { get { return ordinal_; } }
			
			/// <summary> Gets the ordinal value of the source pair as an IMultiValue . </summary>
			public IMultiValue multiValueOrdinal { get { return ordinal; } }
			
			/// <summary> Gets the text value of the source pair. </summary>
			public string text { get { return text_; } }

			internal SourcePair(int ordinal, string text) {
				text_ = text;
				ordinal_ = (Direction)ordinal;
			}
		}

		/// <summary> This array contains one source pair for each Direction value. </summary>
		public static readonly SourcePair[] sourcePairs = { 
			new SourcePair(_undefined_, ""),
			new SourcePair(Input, "input"),
			new SourcePair(Output, "output"),
			new SourcePair(Bidirectional, "bidirectional") 
		};

		/// <summary> Creates a new Direction from an integer value. </summary>
		/// <param name="ordinal"> The ordinal value for the new Direction. </param>
		/// <exception cref="ArgumentOutOfRangeException"> Thrown if the ordinal is negative or greater than the TopValue.</exception>
		public Direction(int ordinal) {
			if (ordinal < 0 || ordinal > TopValue)
				throw new ArgumentOutOfRangeException("ordinal", ordinal, "Invalid value for multi value struct");
			this.ordinal = ordinal;
		}

		/// <summary> Implicit conversion from Direction to int. </summary>
		/// <param name="val"> The Direction to convert. </param>
		/// <returns> An int containing the converted valaue. </returns>
		public static implicit operator int(Direction val) {
			return val.ordinal;
		}

		/// <summary> Implicit conversion from int to Direction. </summary>
		/// <param name="ordinal"> The int to convert. </param>
		/// <returns> An Direction containing the converted value. </returns>
		public static implicit operator Direction(int ordinal) {
			return new Direction(ordinal);
		}

		/// <summary> Explicit conversion from Direction to string. </summary>
		/// <param name="val"> The Direction to convert. </param>
		/// <returns> A string containing the converted valaue. </returns>
		public static explicit operator string(Direction val) {
			return val.ToString();
		}

		/// <summary> Implicit conversion from string to Direction. </summary>
		/// <param name="input"> The string to convert. </param>
		/// <returns> An Direction containing the converted value. </returns>
		public static implicit operator Direction(string input) {
			return Parse(input);
		}

		/// <summary> Performs an equality comparison with another object. </summary>
		/// <param name="val"> The object to compare this one against. </param>
		/// <returns> True if the two objects are equal, otherwise false. </returns>
		public override bool Equals(object val) {
			return (val is Direction && ((Direction)val).ordinal == this.ordinal);
		}

		/// <summary> Creates a hash code for the Direction. </summary>
		/// <returns> An int containing the hash code. </returns>
		public override int GetHashCode() {
			return this.ordinal;
		}

		/// <summary> Creates a textual representation of the Direction. </summary>
		/// <returns> A string containing the textual respresentation. </returns>
		public override string ToString() {
			return Utl.MultiValueText(this);
		}

		/// <summary> Parses a string containing a textual representation of an Direction. </summary>
		/// <param name="input"> The string containing the textual representation. </param>
		/// <returns> An Direction which is the result of the parse, or _undefined_ if the parse fails. </returns>
		public static Direction Parse(string input) {
			return Utl.ParseMultiValue(input, sourcePairs, false);
		}
	}
}
