using System;
using System.Data;
using Persistate;

namespace DeviceNetwork.Model
{
	
	// This Network partial class has been generated by Persistate.  Do
	// not modify as the entire file is recreated on each generation.

	[System.Diagnostics.DebuggerDisplay("Network {NominativeText}")]	
	public partial class Network : Persistent
	{
		private static ObjectClass objClass = null;	// set at start of session

		/// <summary> Sets the objClass static field for this class. </summary>
		public new static void SetObjectClass(ObjectClass oc) {
			objClass = oc;
		}
		/// <summary> Gets the ObjectClass object associated with this object. </summary>
		public override ObjectClass Class {
			get { return objClass; }
		}
		/// <summary> Gets the ObjectClass object associated with this class. </summary>
		public new static ObjectClass ItsObjectClass {
			get { return objClass; }
		}
		/// <summary> Creates a new Network with default property values </summary>
		public Network() : this(true, true) { 
		}
		/// <exclude />
		/// <summary> Creates a new Network with optional default property values </summary>
		public Network(bool initScalars, bool initCollections) : base(false, false) {
			InitialiseMembers(initScalars, initCollections);
		}
		/// <exclude />
		/// <summary> Creates a new Network with its reference and parent. </summary>
		protected Network(Reference thisObj, IReference parentObj) 
			: base(thisObj, parentObj) {}

		/// <summary> Gets the class flags for the Network class. </summary>
		public override FlagSet ClassFlags {
			get { return new FlagSet(FlagSet.CloneOnMutate |FlagSet.UseCache |FlagSet.Singleton |FlagSet.SaveInConfiguration); }
		}
		/// <exclude />
		/// <summary> Creates a new Network from data read from persistent storage. </summary>
		public new static Network CreateFromDatabase(Database db, IDataReader dr, Reference thisObj, Persistent parentObj) {
			Network obj = new Network(thisObj, parentObj);
			obj.FillFromDatabase(db, dr);
			return obj;
		}
		/// <exclude />
		/// <summary> Populates this object from data read from persistent storage. </summary>
		public override void FillFromDatabase(Database db__, IDataReader dr__) {
			base.FillFromDatabase(db__, dr__);
		}
		/// <exclude />
		/// <summary> Populates persistent storage update parameters from this object. </summary>
		public override bool SaveToDatabase(Database db__, Reference id__, object context__) {
			bool reSave__;
			do {
				db__.SetParameter("id", id__);
				db__.SetParameter("parent", ParentReference);
				db__.SetParameter("oldVersion", PreviousVersion == null
					? VersionNumber - 1 : PreviousVersion.VersionNumber);
				db__.SetParameter("newVersion", VersionNumber);
				if (!db__.SaveObject(context__, objClass, out reSave__))
					return false;
			} while (reSave__);		// save again if an update conflict on first try was resolved
			return true;
		}
		/// <exclude />
		/// <summary> Creates a new Network from a Persistate.Message. </summary>
		public new static Network CreateFromMessage(Message message, Reference thisObj, IReference parentObj) {
			Network obj = new Network(thisObj, parentObj);
			obj.FillFromMessage(message);
			return obj;
		}
		/// <exclude />
		/// <summary> Sets a single member value for a given slot from a message. </summary>
		protected override void SetMemberFromMessage(int slot__, int length__, Message message__) {
			switch (slot__) {
				default: base.SetMemberFromMessage(slot__, length__, message__); break;
			}
		}
		/// <exclude />
		/// <summary> Populates a Persistate.Message from this object. </summary>
		protected override void SaveToMessage(Message message__, bool topLevel__) {
			base.SaveToMessage(message__, false);
			if (topLevel__)
				message__.Append(-1);
		}
		/// <exclude />
		/// <summary> Initialises members of a Network object to default values. </summary>
		public override void InitialiseMembers(bool initScalars__, bool initCollections__) {
			base.InitialiseMembers(initScalars__, initCollections__);
			if (initScalars__) {
			}
			if (initCollections__) {
				deviceTypes = DeviceType.Collection(this, DeviceTypesFlagSet, 3, false);
				connectorTypes = ConnectorType.Collection(this, ConnectorTypesFlagSet, 4, false);
				cableTypes = CableType.Collection(this, CableTypesFlagSet, 5, false);
			}
		}
		/// <exclude />
		/// <summary> Removes this Network and all objects under it from persistent storage. </summary>
		public override void DePersist(object context__) {
			foreach (DeviceType obj in DeviceTypes)
				obj.DePersistFrom(DeviceTypes, context__);
			foreach (ConnectorType obj in ConnectorTypes)
				obj.DePersistFrom(ConnectorTypes, context__);
			foreach (CableType obj in CableTypes)
				obj.DePersistFrom(CableTypes, context__);
			base.DePersist(context__);
		}
		/// <exclude />
		/// <summary> calls a method for every node in the persistent tree under this object. </summary>
		public override bool CallTree(CallTreeData callTreeData__, int slot__) {
			if (callTreeData__.RootFirst && !base.CallTree(callTreeData__, slot__))
				return false;
			Devices.CallTree(callTreeData__, 1);
			Cables.CallTree(callTreeData__, 2);
			DeviceTypes.CallTree(callTreeData__, 3);
			ConnectorTypes.CallTree(callTreeData__, 4);
			CableTypes.CallTree(callTreeData__, 5);
			if (!callTreeData__.RootFirst)
				base.CallTree(callTreeData__, slot__);
			return true;
		}
		/// <summary> Gets the value of the member property with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the member with the given slot. </returns>
		public override object GetMemberValue(int slot__) {
			switch (slot__) {
				case 1: return Devices;
				case 2: return Cables;
				case 3: return DeviceTypes;
				case 4: return ConnectorTypes;
				case 5: return CableTypes;
				default: return base.GetMemberValue(slot__);
			}
		}
		/// <summary> Sets the value of the member property with a particularn slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the member with the given slot. </param>
		public override void SetMemberValue(int slot__, object value__) {
			switch (slot__) {
				default: base.SetMemberValue(slot__, value__); break;
			}
		}
		/// <summary> Gets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <returns> An object containing the value of the field with the given slot. </returns>
		public override object GetFieldValue(int slot__) {
			switch (slot__) {
				case 3: return deviceTypes;
				case 4: return connectorTypes;
				case 5: return cableTypes;
				default: return base.GetFieldValue(slot__);
			}
		}
		/// <summary> Sets the value of the field backing the member with a particular slot number. </summary>
		/// <param name="slot__"> The member slot number. </param>
		/// <param name="value__"> The new value to set into the field with the given slot. </param>
		public override void SetFieldValue(int slot__, object value__) {
			switch (slot__) {
				default: base.SetFieldValue(slot__, value__); break;
			}
		}
		/// <summary> Creates a Network collection to contain provisional objects. </summary>
		/// <returns> An empty IndexedList(Network) collection. </returns>
		public new static IndexedList<Network> Collection() {
			return new IndexedList<Network>(ItsObjectClass, null, FlagSet.Associated, 0, false, 0, -1);
		}
		/// <summary> Creates a Network collection to contain persistent objects. </summary>
		/// <param name="parent"> The parent object of the collection. </param>
		/// <param name="flags"> A FlagSet containing the collection flags. </param>
		/// <param name="slot"> The slot of its parent member containing the collection. </param>
		/// <param name="getData"> If true, objects belonging in the collection are fetched from persistent storage. </param>
		/// <returns> An IndexedList(Network) containing the new collection. </returns>
		public new static IndexedList<Network> Collection(Persistent parent, FlagSet flags, int slot, bool getData) {
			return new IndexedList<Network>(ItsObjectClass, parent, flags, slot, getData, 0, -1);
		}
		//		Property for devices
		private SessionSpecific<IndexedList<Device>> devices;
		private static readonly FlagSet DevicesFlagSet = FlagSet.MultipleObject |FlagSet.MultipleMany;
		/// <summary> Property for devices. </summary> 
		public IndexedList<Device> Devices {
			get {
				IndexedList<Device> collection = devices.Value;
				if (collection == null) lock (locker) if (devices.Value == null) {
					collection = Device.Collection(this, DevicesFlagSet, 1, false);
					devices.Value = collection;
				}
				return collection;
			}
		}
		/// <summary> Obtains the Device with a particular Name. </summary>
		/// <param name="key">The Name to find.</param>
		/// <returns>The found Device or null if none was found.</returns>
		public Device DeviceWithName(object key) {
			IndexedList<Device> collection = Devices;
			collection.Clear();
			GetChildren(collection, Device.ItsObjectClass, "Name", key);
			return (collection.Count > 0 ? collection[0] : null);
		}
		/// <summary> Finds the Devices with a particular DeviceType. </summary>
		/// <param name="key"> The DeviceType to search for. </param>
		/// <returns> A collection containing the Devices with the given DeviceType. </returns>
		public IndexedList<Device> DevicesWithDeviceType(object key) {
			IndexedList<Device> collection = Devices;
			collection.Clear();
			return GetChildren(collection, Device.ItsObjectClass, "DeviceType", key);
		}
		/// <summary> Finds the Devices with a particular SerialNumber. </summary>
		/// <param name="key"> The SerialNumber to search for. </param>
		/// <returns> A collection containing the Devices with the given SerialNumber. </returns>
		public IndexedList<Device> DevicesWithSerialNumber(object key) {
			IndexedList<Device> collection = Devices;
			collection.Clear();
			return GetChildren(collection, Device.ItsObjectClass, "SerialNumber", key);
		}
		
		/// <summary> Obtains a set of Devices which match a set of keys. /// </summary>
		/// <param name="keys">One key should be supplied for each discriminative
		/// member of the Device class.</param>
		/// <returns>A list of Choice objects, one for each matched Device.</returns>
		public IndexedList<Choice> DevicesLike(params object[] keys) {
			IndexedList<Choice> collection = Choice.Collection(this, DevicesFlagSet, 1, false);
			return GetChildren(collection, Device.ItsObjectClass, "discriminate", keys);
		}
		//		Property for cables
		private SessionSpecific<IndexedList<Cable>> cables;
		private static readonly FlagSet CablesFlagSet = FlagSet.MultipleObject |FlagSet.MultipleMany;
		/// <summary> Property for cables. </summary> 
		public IndexedList<Cable> Cables {
			get {
				IndexedList<Cable> collection = cables.Value;
				if (collection == null) lock (locker) if (cables.Value == null) {
					collection = Cable.Collection(this, CablesFlagSet, 2, false);
					cables.Value = collection;
				}
				return collection;
			}
		}
		/// <summary> Obtains the Cable with a particular Name. </summary>
		/// <param name="key">The Name to find.</param>
		/// <returns>The found Cable or null if none was found.</returns>
		public Cable CableWithName(object key) {
			IndexedList<Cable> collection = Cables;
			collection.Clear();
			GetChildren(collection, Cable.ItsObjectClass, "Name", key);
			return (collection.Count > 0 ? collection[0] : null);
		}
		/// <summary> Finds the Cables with a particular CableType. </summary>
		/// <param name="key"> The CableType to search for. </param>
		/// <returns> A collection containing the Cables with the given CableType. </returns>
		public IndexedList<Cable> CablesWithCableType(object key) {
			IndexedList<Cable> collection = Cables;
			collection.Clear();
			return GetChildren(collection, Cable.ItsObjectClass, "CableType", key);
		}
		/// <summary> Finds the Cables with a particular CableColour. </summary>
		/// <param name="key"> The CableColour to search for. </param>
		/// <returns> A collection containing the Cables with the given CableColour. </returns>
		public IndexedList<Cable> CablesWithCableColour(object key) {
			IndexedList<Cable> collection = Cables;
			collection.Clear();
			return GetChildren(collection, Cable.ItsObjectClass, "CableColour", key);
		}
		
		/// <summary> Obtains a set of Cables which match a set of keys. /// </summary>
		/// <param name="keys">One key should be supplied for each discriminative
		/// member of the Cable class.</param>
		/// <returns>A list of Choice objects, one for each matched Cable.</returns>
		public IndexedList<Choice> CablesLike(params object[] keys) {
			IndexedList<Choice> collection = Choice.Collection(this, CablesFlagSet, 2, false);
			return GetChildren(collection, Cable.ItsObjectClass, "discriminate", keys);
		}
		//		Property for device types
		private IndexedList<DeviceType> deviceTypes = null;
		private static readonly FlagSet DeviceTypesFlagSet = FlagSet.MultipleObject;
		/// <summary> Property for device types. </summary> 
		public IndexedList<DeviceType> DeviceTypes {
			get {
				if (deviceTypes == null) lock (locker) if (deviceTypes == null)
					deviceTypes = DeviceType.Collection(this, DeviceTypesFlagSet, 3, true);
				return deviceTypes;
			}
		}
		/// <summary> Gets the number of items in the DeviceTypes collection. </summary>
		public int DeviceTypesCount {
			get { return DeviceTypes.Count; }
		}
		//		Property for connector types
		private IndexedList<ConnectorType> connectorTypes = null;
		private static readonly FlagSet ConnectorTypesFlagSet = FlagSet.MultipleObject;
		/// <summary> Property for connector types. </summary> 
		public IndexedList<ConnectorType> ConnectorTypes {
			get {
				if (connectorTypes == null) lock (locker) if (connectorTypes == null)
					connectorTypes = ConnectorType.Collection(this, ConnectorTypesFlagSet, 4, true);
				return connectorTypes;
			}
		}
		/// <summary> Gets the number of items in the ConnectorTypes collection. </summary>
		public int ConnectorTypesCount {
			get { return ConnectorTypes.Count; }
		}
		//		Property for cable types
		private IndexedList<CableType> cableTypes = null;
		private static readonly FlagSet CableTypesFlagSet = FlagSet.MultipleObject;
		/// <summary> Property for cable types. </summary> 
		public IndexedList<CableType> CableTypes {
			get {
				if (cableTypes == null) lock (locker) if (cableTypes == null)
					cableTypes = CableType.Collection(this, CableTypesFlagSet, 5, true);
				return cableTypes;
			}
		}
		/// <summary> Gets the number of items in the CableTypes collection. </summary>
		public int CableTypesCount {
			get { return CableTypes.Count; }
		}
		/// <summary> Returns property value for given key number. </summary>
		/// <param name="keyNum__"> The key number to use. </param>
		/// <returns> an object containing the value of the property indicated by the given key.  </returns>
		public override object GetKey(int keyNum__) {
			switch (keyNum__) {
				default: return base.GetKey(keyNum__);
			}
		}
		/// <summary> Gets a string containing values of nominative properties. </summary>
		public override string NominativeText {
			get { return Utl.Join(AnnotationSeparator, base.NominativeText); }
		}
		/// <summary> Gets a string containing values of discriminative properties. </summary>
		public override string DiscriminativeText {
			get { return Utl.Join(AnnotationSeparator, base.DiscriminativeText); }
		}
	}

}